using System;

namespace Python
{
	public class PythonInteger : PythonNumber
	{
		public PythonInteger()
		{
		}

		public static PythonInteger Create(int value)
		{
			return PythonException.ThrowIfInvalid(NativeMethods.PyInt_FromInt32(value));
		}

		[CLSCompliant(false)]
		public static PythonInteger Create(uint value)
		{
			return PythonException.ThrowIfInvalid(NativeMethods.PyInt_FromInt64((long)value));
		}

		public static PythonInteger Create(long value)
		{
			return PythonException.ThrowIfInvalid(NativeMethods.PyInt_FromInt64(value));
		}

		[CLSCompliant(false)]
		public static PythonInteger Create(ulong value)
		{
			return PythonException.ThrowIfInvalid(NativeMethods.PyInt_FromInt64((long)value));
		}

		public static PythonInteger Create(short value)
		{
			return PythonException.ThrowIfInvalid(NativeMethods.PyInt_FromInt32(value));
		}

		[CLSCompliant(false)]
		public static PythonInteger Create(ushort value)
		{
			return PythonException.ThrowIfInvalid(NativeMethods.PyInt_FromInt32(value));
		}

		public static PythonInteger Create(byte value)
		{
			return PythonException.ThrowIfInvalid(NativeMethods.PyInt_FromInt32(value));
		}

		[CLSCompliant(false)]
		public static PythonInteger Create(sbyte value)
		{
			return PythonException.ThrowIfInvalid(NativeMethods.PyInt_FromInt32(value));
		}

		public int ToInt32()
		{
			int value = NativeMethods.PyInt_ToInt32(this);
			PythonException.ThrowIfErrorOccurred();
			return value;
		}

		public long ToInt64()
		{
			long value = NativeMethods.PyInt_ToInt64(this);
			PythonException.ThrowIfErrorOccurred();
			return value;
		}
	}
}