using System;
using System.Collections.Generic;

namespace Python
{
	public class PythonIterator<T> : PythonObject, IEnumerator<T> where T : PythonObject, new()
	{
		private T current;

		public PythonIterator()
		{
		}

		public T Current
		{
			get
			{
				return current;
			}
		}

		object System.Collections.IEnumerator.Current
		{
			get
			{
				return current;
			}
		}

		public unsafe bool MoveNext()
		{
			this.current = NativeMethods.PyIter_Next<T>(this);

			if (this.current.IsInvalid)
			{
				PythonException.ThrowIfErrorOccurred();
				return false;
			}

			return true;
		}

		void System.Collections.IEnumerator.Reset()
		{
			throw new NotSupportedException();
		}
	}

	public class PythonIterable<T> : PythonObject, IEnumerable<T> where T : PythonObject, new()
	{
		public PythonIterable()
		{
		}

		public IEnumerator<T> GetEnumerator()
		{
			return GetIterator<T>();
		}

		System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
		{
			return GetEnumerator();
		}
	}
}