using System;

namespace Python
{
	public class PythonModule : PythonObject
	{
		public PythonModule()
		{
		}

		public static PythonModule Import(string module)
		{
			return PythonException.ThrowIfInvalid(NativeMethods.PyImport_ImportModule(module));
		}

		public string Filename
		{
			get
			{
				string filename = NativeMethods.PyModule_GetFilename(this);
				PythonException.ThrowIfErrorOccurred();
				return filename;
			}
		}

		public string Name
		{
			get
			{
				string name = NativeMethods.PyModule_GetName(this);
				PythonException.ThrowIfErrorOccurred();
				return name;
			}
		}
	}
}