using System;
using System.Runtime.InteropServices;

namespace Python
{
	public class PythonType : PythonObject
	{
		/*
		public static readonly PythonType BooleanType;
		public static readonly PythonType DictType;
		public static readonly PythonType IntType;
		public static readonly PythonType ListType;
		public static readonly PythonType ModuleType;
		public static readonly PythonType NoneType;
		public static readonly PythonType StringType;
		public static readonly PythonType TupleType;
		public static readonly PythonType TypeType;
		public static readonly PythonType UnicodeType;

		static PythonType()
		{
		    using (PythonModule module = PythonModule.Import("types"))
		    {
		        BooleanType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "BooleanType"));
		        DictType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "DictType"));
		        IntType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "IntType"));
		        ListType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "ListType"));
		        ModuleType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "ModuleType"));
		        NoneType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "NoneType"));
		        StringType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "StringType"));
		        TupleType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "TupleType"));
		        TypeType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "TypeType"));
		        UnicodeType = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrStringAsType(module, "UnicodeType"));
		    }
		}
		*/

		private static IntPtr noneType;

		public static PythonType NoneType
		{
			get
			{
				return GetType(ref noneType, "NoneType");
			}
		}

		private string name;
		private string module;

		public PythonType()
		{
		}

		public unsafe string Name
		{
			get
			{
				if (base.IsInvalid)
				{
					throw new InvalidOperationException();
				}
				if (null == this.name)
				{
					NativeMethods.PyTypeObject* op = (NativeMethods.PyTypeObject*)base.handle;
					this.name = Marshal.PtrToStringAnsi(op->tp_name);
				}

				return this.name;
			}
		}

		public string Module
		{
			get
			{
				if (base.IsInvalid)
				{
					throw new InvalidOperationException();
				}
				if (null == this.module)
				{
					using (PythonString s = PythonException.ThrowIfInvalid(NativeMethods.PyObject_GetAttrString<PythonString>(this, "__module__")))
					{
						this.module = s.ToString();
					}
				}

				return this.module;
			}
		}

		public bool IsSubtypeOf(PythonType type)
		{
			if (null == type)
			{
				throw new ArgumentNullException("type");
			}
			if (base.IsInvalid)
			{
				throw new InvalidOperationException();
			}
			if (base.handle == type.handle)
			{
				return true;
			}

			return PythonException.ThrowIfNegative(NativeMethods.PyType_IsSubtype(this, type)) > 0;
		}
	}
}